/*
 * playlistaspectstatisticsgatherer.cpp
 *
 *  Created on: 20.04.2010
 *      Author: darkstar
 */

#include "playlistaspectstatisticsgatherer.h"
#include "debug.h"

PlayListAspectStatisticsGatherer::PlayListAspectStatisticsGatherer()
	:	QObject(),
	 	PlayListAspectExtension(),
		totalPlaytime_(0),
		totalFilesize_(0),
		itemCount_(0)
{

}

PlayListAspectStatisticsGatherer::~PlayListAspectStatisticsGatherer()
{

}

void PlayListAspectStatisticsGatherer::execute()
{
	DENTERMETHOD("PlayListAspectStatisticsGatherer::execute()");
	DTIMERINIT(ptfs);

	sqlite3_stmt *vm;
	QString query = "SELECT SUM(playtime), SUM(filesize), COUNT(filesize) FROM " + dbSafeString(inputViewSource()) + ";";
	sqlite3_prepare_v2(playListAspect()->playList()->mediaDatabase()->db(), query, -1, &vm, 0);
	if (sqlite3_step(vm) == SQLITE_ROW)
	{
		totalPlaytime_ = sqlite3_column_int64(vm, 0);
		totalFilesize_ = sqlite3_column_int64(vm, 1);
		itemCount_ = sqlite3_column_int64(vm, 2);
	}
	sqlite3_finalize(vm);

	DTIMERINIT(temp);
	emit statisticsUpdated();
	DTIMERPRINT(temp, "emit statisticsUpdated();");

	DTIMERPRINT(ptfs, "totalPlaytime, totalFilesize");
	DEXITMETHOD("PlayListAspectStatisticsGatherer::execute()");
}
